=== debian/changelog ===
dpf-plugins (1.6+ds-2) unstable; urgency=medium

  * Fix FTBS on armel
  * Add libglm-dev, libxcursor-dev & libxrandr-de to B-Ds
  * Remove libjack-dev from B-Ds
    + https://github.com/DISTRHO/DPF-Plugins/issues/23#issuecomment-1360298123
  * Change my email address

 -- Dennis Braun <snd@debian.org>  Wed, 21 Dec 2022 20:00:58 +0100

dpf-plugins (1.6+ds-1) unstable; urgency=medium

  * New upstream version 1.6

  [ Dennis Braun ]
  * Introduce the dpf-source package, sources of the DISTRHO Plugin Framework
  * Build verbose, and try to fix CPPFLAGS missing
  * Refresh patchset, use rtmidi from system too
  * Prefer libjack-dev over libjack-jackd2-dev

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Fix passing of *FLAGS
  * Verbose builds
  * Replace dh_auto_install override with an execute_after
  * Allow for cross-compilation
  * Do not optimized binaries beyond our base architecture
  * Pass CPPFLAGS via CFLAGS/CXXFLAGS
  * Make sure to leave the sources in a pristine state
  * Make blhc ignore lines starting with "Compiling ..."

  [ Dennis Braun ]
  * d/not-installed: clap and vst3 format is so far not in use
  * d/copyright: Remove obsolete vestige entry
  * Use DejaVuSans from fonts-dejavu-core
  * Refresh lintian-overrides

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Update d/copyright
    + Exclude binary artifacts from the package import
    + Fix typo in upstream URL
    + Add 'licensecheck' target to d/rules
    + Generate d/copyright_hints
  * Automatically add repacksuffix when importing new upstream sources

 -- Dennis Braun <snd@debian.org>  Sun, 18 Dec 2022 21:56:25 +0100
