=== debian/control ===
Source: dpf-plugins
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dennis Braun <snd@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libgl1-mesa-dev,
 libglm-dev,
 libglu1-mesa-dev,
 liblo-dev,
 libprojectm-dev,
 librtaudio-dev,
 librtmidi-dev,
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxrandr-dev,
 pkg-config,
Homepage: https://github.com/falkTX/DPF-Plugins
Vcs-Git: https://salsa.debian.org/multimedia-team/dpf-plugins.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/dpf-plugins
Standards-Version: 4.6.1
Rules-Requires-Root: no

Package: dpf-plugins
Architecture: any
Depends:
 dpf-plugins-common,
 dpf-plugins-dssi,
 dpf-plugins-ladspa,
 dpf-plugins-lv2,
 dpf-plugins-vst,
 ${misc:Depends},
Description: Audio plugin collection from DISTRHO (metapackage)
 Metapackage pulling-in collection of DPF-based plugins in
 LADSPA, DSSI, LV2 and VST2 formats.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-common
Architecture: any
Depends:
 projectm-data,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Audio plugin collection from DISTRHO (common files)
 Common files for collection of DPF-based plugins in
 LADSPA, DSSI, LV2 and VST2 formats.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-ladspa
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 ladspa-plugin,
Description: Audio plugin collection from DISTRHO (LADSPA plugins)
 Collection of DPF-based plugins in LADSPA format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-lv2
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lv2-plugin,
Description: Audio plugin collection from DISTRHO (LV2 plugins)
 Collection of DPF-based plugins in LV2 format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-vst
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 vst-plugin,
Description: Audio plugin collection from DISTRHO (VST2 plugins)
 Collection of DPF-based plugins in VST2 format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-dssi
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 dssi-plugin,
Description: Audio plugin collection from DISTRHO (DSSI plugins)
 Collection of DPF-based plugins in DSSI format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-source
Architecture: all
Depends:
 fonts-dejavu-core,
 python3:any,
 ${misc:Depends},
Description: DISTRHO Plugin Framework (Source files)
 DPF is designed to make development of new plugins an easy
 and enjoyable task.
 It allows developers to create plugins with custom UIs
 using a simple C++ API.
 The framework facilitates exporting various different
 plugin formats from the same code-base.
