## dpf-plugins 1.7%2Bds

=== debian/changelog ===
dpf-plugins (1.7+ds-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Jan 2026 20:26:48 +0000

dpf-plugins (1.7+ds-3) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Also link against system's RtAudio
  * Add patch to fix compilation with RtAudio6 (Closes: #1051558)
  * Bump standards version to 4.7.0
  * Apply 'wrap-and-sort -ast'

  [ Dennis Braun ]
  * Change B-D from pkg-config to pkgconf
  * Use default salsa ci config

 -- Dennis Braun <snd@debian.org>  Sat, 17 Aug 2024 14:35:06 +0200

dpf-plugins (1.7+ds-2) unstable; urgency=medium

  * Source-only upload

 -- Dennis Braun <snd@debian.org>  Sun, 27 Aug 2023 23:49:43 +0200

dpf-plugins (1.7+ds-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * d/control: update Homepage link

  [ Dennis Braun ]
  * New upstream version 1.7+ds
  * Build-Depends: libgl1-mesa-dev => libgl-dev
  * Bump Standards-Version to 4.6.2
  * Provide the clap package of dpf-plugins
  * Provide the vst3 package of dpf-plugins
  * Add the new plugin packages to the Depends of the meta package
  * Refresh patches, drop armel patch applied by upstream
  * d/copyright: Refresh file entries, bump years

 -- Dennis Braun <snd@debian.org>  Thu, 27 Jul 2023 16:04:49 +0200
